.Equ ALE                 = 0
.Equ CLE                 = 1
.Equ CE_                 = 2
.Equ RB                  = 3
.Equ WP_                 = 4
.Equ RE_                 = 5
.Equ WE_                 = 6
.Equ PortOutData         = PORTA
.Equ PortDirectionData   = DDRA
.Equ PortInData          = PINA
.Equ PortCommandOut      = PORTC
.Equ PortCommandDiretion = DDRC
.Equ PortCommandIn       = PINC
;***************************************************************************
SetupDriver:;This routine is for seting resources
	Sbi PortCommandDiretion,ALE
	Sbi PortCommandDiretion,CLE
	Sbi PortCommandDiretion,CE_
	Cbi PortCommandDiretion,RB
	Sbi PortCommandDiretion,WP_
	Sbi PortCommandDiretion,RE_
	Sbi PortCommandDiretion,WE_
;Initialize port comand and pull up-s
	Cbi PortCommandOut,ALE
	Cbi PortCommandOut,CLE
	Sbi PortCommandOut,CE_
	Sbi PortCommandOut,RB
	Sbi PortCommandOut,WP_
	Sbi PortCommandOut,RE_
	Sbi PortCommandOut,WE_
;Initialize port data directions
	Clr R16
	Out PortOutData,R16;Set data port output
;Initialize pull up for data port
	Ser R16
	Out PortOutData,R16;Set data port with pull up
	Ret
;***************************************************************************
;R0:R1 = Col
;R2:R3:R4 = Row
WriteToFlashWithAdress_:; This is comand to initiate write comand to page
	Push R16
	Push R17
	Ldi R17,'W'
LoopBusyInWriteCommand:
	Sbis PortCommandIn,RB
	Rjmp LoopBusyInWriteCommand
	Cbi PortCommandOut,CE_;Select chip
	Rcall SeteazaPortulDateFlashCaIesire
;-----------------------------------
	Ldi R16,0x80
	Out PortOutData,R16;Trimite begin command read
	Sbi PortCommandOut,CLE
	Cbi PortCommandOut,WE_
	Rcall DelayFlash
	Sbi PortCommandOut,WE_
	Cbi PortCommandOut,CLE
	Rjmp SendAdressToFlashChip
;******************************
CopyBackFlashMemory_:;This comand is for Write back ( apend to page )
	Push R16
	Push R17
	Ldi R17,'C'
	Rjmp EsteOperatiuneaDeCopyBack
;******************************
ReadFromFlashWithAdress_:; This is comand to initiate read comand
	Push R16
	Push R17
	Ldi R17,'R'
EsteOperatiuneaDeCopyBack:
LoopBusyInreadCommand:
	Sbis PortCommandIn,RB
	Rjmp LoopBusyInreadCommand
	Cbi PortCommandOut,CE_;Selecteaza chipul
	Rcall SeteazaPortulDateFlashCaIesire
;-----------------------------------
	Ldi R16,0x00
	Out PortOutData,R16;Send begin read comand
	Sbi PortCommandOut,CLE
	Cbi PortCommandOut,WE_
	Rcall DelayFlash
	Sbi PortCommandOut,WE_
	Cbi PortCommandOut,CLE
	Rjmp SendAdressToFlashChip
;******************************
SendAdressToFlashChip:
	Rcall DelayFlash
	Out PortOutData,R0;Send Adress col0
	Sbi PortCommandOut,ALE
	Cbi PortCommandOut,WE_
	Rcall DelayFlash
	Sbi PortCommandOut,WE_
;-----------------------------------
	Rcall DelayFlash
	Out PortOutData,R1;Send Adress col1
	Cbi PortCommandOut,WE_
	Rcall DelayFlash
	Sbi PortCommandOut,WE_
;-----------------------------------
	Rcall DelayFlash
	Out PortOutData,R2;Send Adress row0
	Cbi PortCommandOut,WE_
	Rcall DelayFlash
	Sbi PortCommandOut,WE_
;-----------------------------------
	Rcall DelayFlash
	Out PortOutData,R3;Send Adress row1
	Cbi PortCommandOut,WE_
	Rcall DelayFlash
	Sbi PortCommandOut,WE_
;-----------------------------------
	Rcall DelayFlash
	Out PortOutData,R4;Send Adress row2
	Cbi PortCommandOut,WE_
	Rcall DelayFlash
	Sbi PortCommandOut,WE_
	Cbi PortCommandOut,ALE
;******************************
	Cpi R17,0
	Breq NuEsteOperatiaDeRedareDinChipulFlash
	Cpi R17,'W'
	Breq NuEsteOperatiaDeRedareDinChipulFlash
	Cpi R17,'C'
	Breq EsteOperatiaDeRedarePentruOperatiuneaCopyBack
	Rcall DelayFlash
	Ldi R16,0x30
	Out PortOutData,R16;Send end read comand
	Sbi PortCommandOut,CLE
	Cbi PortCommandOut,WE_
	Rcall DelayFlash
	Sbi PortCommandOut,WE_
	Cbi PortCommandOut,CLE
	Rjmp FinishOperatiuneaDeRedare
;******************************
EsteOperatiaDeRedarePentruOperatiuneaCopyBack:
	Rcall DelayFlash
	Ldi R16,0x35
	Out PortOutData,R16;Send end read comand
	Sbi PortCommandOut,CLE
	Cbi PortCommandOut,WE_
	Rcall DelayFlash
	Sbi PortCommandOut,WE_
	Cbi PortCommandOut,CLE
;-----------------------------------
LoopBusyInCopyBackCommand:
	Sbis PortCommandIn,RB
	Rjmp LoopBusyInCopyBackCommand
	Ldi R16,0x85
	Out PortOutData,R16;Send begin read comand
	Sbi PortCommandOut,CLE
	Cbi PortCommandOut,WE_
	Rcall DelayFlash
	Sbi PortCommandOut,WE_
	Cbi PortCommandOut,CLE
	Clr R17
	Rjmp SendAdressToFlashChip
;******************************
FinishOperatiuneaDeRedare:
NuEsteOperatiaDeRedareDinChipulFlash:
	Sbi PortCommandOut,CE_;Unselect chipul
	Pop R17
	Pop R16
	Ret
;***************************************************************************
ReadByteFromFlash_:;Read byte from selected page
	Push R16
	Ser R16
	Out PortOutData,R16
	Rcall SeteazaPortulDateFlashCaIntrare
LoopBusyInreadCommand_:
	Sbis PortCommandIn,RB
	Rjmp LoopBusyInreadCommand_
	Cbi PortCommandOut,CE_;Selecteaza chipul
	Cbi PortCommandOut,RE_
	Rcall DelayFlash
	In R5,PortInData
	Sbi PortCommandOut,RE_
	Sbi PortCommandOut,CE_;Deselecteaza chipul
	Pop R16
	Ret
;R5 = Byte read
;***************************************************************************
;R5 = Byte to be write
WriteByteToFlash_:;Write byte to selected page
	Rcall DelayFlash
	Out PortOutData,R5
	Cbi PortCommandOut,CE_;Deselecteaza chipul
	Cbi PortCommandOut,WE_
	Rcall DelayFlash
	Sbi PortCommandOut,WE_
	Sbi PortCommandOut,CE_;Deselecteaza chipul
	Ret
;***************************************************************************
WriteEndDataToFlash_:; This comand is for ending write page
	Push R16
	Ldi R16,0x10
	Out PortOutData,R16;Trimite end comanda read
	Cbi PortCommandOut,CE_;Deselecteaza chipul
	Sbi PortCommandOut,CLE
	Cbi PortCommandOut,WE_
	Rcall DelayFlash
	Sbi PortCommandOut,WE_
	Cbi PortCommandOut,CLE
	Sbi PortCommandOut,CE_;Deselecteaza chipul
	Pop R16
	Ret
;***************************************************************************
;R2:R3:R4 = Blok erase adress
BlokEraseFromFlash_:
	Push R16
LoopBusyInEraseCommand:
	Sbis PortCommandIn,RB
	Rjmp LoopBusyInEraseCommand
	Cbi PortCommandOut,CE_;Selecteaza chipul
	Rcall SeteazaPortulDateFlashCaIesire
	Ldi R16,0x60
	Out PortOutData,R16;Send begin erase comand
	Sbi PortCommandOut,CLE
	Cbi PortCommandOut,WE_
	Rcall DelayFlash
	Sbi PortCommandOut,WE_
	Cbi PortCommandOut,CLE
;-----------------------------------
	Rcall DelayFlash
	Out PortOutData,R2;Send adresa row0
	Sbi PortCommandOut,ALE
	Cbi PortCommandOut,WE_
	Rcall DelayFlash
	Sbi PortCommandOut,WE_
;-----------------------------------
	Rcall DelayFlash
	Out PortOutData,R3;Send adresa row1
	Cbi PortCommandOut,WE_
	Rcall DelayFlash
	Sbi PortCommandOut,WE_
;-----------------------------------
	Rcall DelayFlash
	Out PortOutData,R4;Send adresa row2
	Cbi PortCommandOut,WE_
	Rcall DelayFlash
	Sbi PortCommandOut,WE_
	Cbi PortCommandOut,ALE
;-----------------------------------
	Rcall DelayFlash
	Ldi R16,0xD0
	Out PortOutData,R16;Send end erase comand
	Sbi PortCommandOut,CLE
	Cbi PortCommandOut,WE_
	Rcall DelayFlash
	Sbi PortCommandOut,WE_
	Cbi PortCommandOut,CLE
	Sbi PortCommandOut,CE_;Unselect chip
	Pop R16
	Ret
;***************************************************************************
ReadIdFromFlash_:
	Push R16
LoopBusyInReadIdCommand:
	Sbis PortCommandIn,RB
	Rjmp LoopBusyInReadIdCommand
	Cbi PortCommandOut,CE_;Selecteaza chipul
	Rcall SeteazaPortulDateFlashCaIesire
;-----------------------------------
	Ldi R16,0x90
	Out PortOutData,R16;Trimite begin command read ID
	Sbi PortCommandOut,CLE
	Cbi PortCommandOut,WE_
	Rcall DelayFlash
	Sbi PortCommandOut,WE_
	Cbi PortCommandOut,CLE
;-----------------------------------
	Rcall DelayFlash
	Ldi R16,0
	Out PortOutData,R16;Trimite adresaregistrului
	Sbi PortCommandOut,ALE
	Cbi PortCommandOut,WE_
	Rcall DelayFlash
	Sbi PortCommandOut,WE_
	Cbi PortCommandOut,ALE
;-----------------------------------
	Rcall DelayFlash
	Cbi PortCommandOut,CE_;Selecteaza chipul
	Cbi PortCommandOut,RE_
	Rcall DelayFlash
	In R0,PortInData
	Sbi PortCommandOut,RE_
	Rcall DelayFlash
;-----------------------------------
	Cbi PortCommandOut,RE_
	Rcall DelayFlash
	In R1,PortInData
	Sbi PortCommandOut,RE_
	Rcall DelayFlash
;-----------------------------------
	Cbi PortCommandOut,RE_
	Rcall DelayFlash
	In R2,PortInData
	Sbi PortCommandOut,RE_
	Rcall DelayFlash
;-----------------------------------
	Cbi PortCommandOut,RE_
	Rcall DelayFlash
	In R3,PortInData
	Sbi PortCommandOut,RE_
	Rcall DelayFlash
;-----------------------------------
	Cbi PortCommandOut,RE_
	Rcall DelayFlash
	In R4,PortInData
	Sbi PortCommandOut,RE_
	Sbi PortCommandOut,CE_;Deselecteaza chipul
	Pop R16
	Ret
;R0:R1:R2:R3:R4 = Is returned id memory number
;***************************************************************************
ReadStatusRegister_:;Read status register from flash memory
	Push R16
LoopBusyInReadStatusRegister:
	Sbis PortCommandIn,RB
	Rjmp LoopBusyInReadStatusRegister
;-----------------------------------
	Ldi R16,0x30
	Out PortOutData,R16;Trimite end comanda read
	Cbi PortCommandOut,CE_;Selecteaza chipul
	Sbi PortCommandOut,CLE
	Cbi PortCommandOut,WE_
	Rcall DelayFlash
	Sbi PortCommandOut,WE_
	Cbi PortCommandOut,CLE
;-----------------------------------
	Rcall DelayFlash
	Cbi PortCommandOut,RE_
	Rcall DelayFlash
	In R5,PortInData
	Sbi PortCommandOut,RE_
	Sbi PortCommandOut,CE_;Selecteaza chipul
	Pop R16
	Ret
;In R5 is returned status data
;***************************************************************************
SeteazaPortulDateFlashCaIesire:
	Push R16
	Ser R16
	Out DDRA,R16
	Pop R16
	Ret
;***************************************************************************
SeteazaPortulDateFlashcaIntrare:
	Push R16
	Clr R16
	Out DDRA,R16
	Pop R16
	Ret
;***************************************************************************
DelayFlash:
	Ret
;***************************************************************************
EndDrvFlashDriver:
